<template>
  <ContentWrap>
    <!-- 搜索工作栏 -->
    <el-form
      class="-mb-15px"
      :model="queryParams"
      ref="queryFormRef"
      :inline="true"
      label-width="68px"
    >
      <el-form-item label="编码" prop="code">
        <el-input
          v-model="queryParams.code"
          placeholder="请输入编码"
          clearable
          @keyup.enter="handleQuery"
          class="!w-240px"
        />
      </el-form-item>
      <el-form-item label="计划下料" prop="requisitionDate">
        <el-date-picker
          v-model="queryParams.requisitionDate"
          value-format="YYYY-MM-DD HH:mm:ss"
          type="daterange"
          @change="handleQuery"
          start-placeholder="开始日期"
          end-placeholder="结束日期"
          :default-time="[new Date('1 00:00:00'), new Date('1 23:59:59')]"
          class="!w-240px"
        />
      </el-form-item>

      <el-form-item label="备注" prop="remark">
        <el-input
          v-model="queryParams.remark"
          placeholder="请输入备注"
          clearable
          @keyup.enter="handleQuery"
          class="!w-240px"
        />
      </el-form-item>

      <el-form-item label="创建时间" prop="createTime">
        <el-date-picker
          v-model="queryParams.createTime"
          value-format="YYYY-MM-DD HH:mm:ss"
          type="daterange"
          @change="handleQuery"
          start-placeholder="开始日期"
          end-placeholder="结束日期"
          :default-time="[new Date('1 00:00:00'), new Date('1 23:59:59')]"
          class="!w-240px"
        />
      </el-form-item>
      <el-form-item>
        <el-button @click="handleQuery"><Icon icon="ep:search" class="mr-5px" /> 搜索</el-button>
        <el-button @click="resetQuery"><Icon icon="ep:refresh" class="mr-5px" /> 重置</el-button>

        <el-button
          type="success"
          plain
          @click="handleExport"
          :loading="exportLoading"
          v-hasPermi="['mes:item-requisition:export']"
        >
          <Icon icon="ep:download" class="mr-5px" /> 导出
        </el-button>
      </el-form-item>
    </el-form>
  </ContentWrap>

  <!-- 列表 -->
  <ContentWrap>
    <!-- <el-tabs v-model="activeName" @tab-click="handleTabClick">
    <el-tab-pane label="所有" name="" />
    <el-tab-pane label="下达" name="2" />
    <el-tab-pane label="投料" name="3" />
    <el-tab-pane label="完成" name="4" />
  </el-tabs> -->

    <el-table v-loading="loading" :data="list" :stripe="true" :show-overflow-tooltip="true">
      <!-- 子表的列表 -->
      <el-table-column type="expand">
        <template #default="scope">
          <el-tabs model-value="itemRequisitionDetail">
            <el-tab-pane label="领料明细" name="itemRequisitionDetail">
              <ItemRequisitionDetailList :item-requisition-id="scope.row.id" />
            </el-tab-pane>
          </el-tabs>
        </template>
      </el-table-column>
      <el-table-column label="编码" align="center" prop="code" min-width="160px" />
      <el-table-column label="计划" align="center" prop="planCode" min-width="160px" />
      <el-table-column label="状态" align="center" prop="status" >
        <template #default="scope">
          <dict-tag :type="DICT_TYPE.MES_PRODUCE_ITEM_REQUISITION" :value="scope.row.status" />
        </template>
      </el-table-column>
      <el-table-column label="生产线" align="center" prop="feedingPipelineName"/>
      <el-table-column label="领料人" align="center" prop="workerName"/>
      <el-table-column label="备注" align="center" prop="remark" />
      <el-table-column
        label="计划下料"
        align="center"
        prop="requisitionDate"
        :formatter="dateFormatter2"
        width="180px"
        sortable
      />
      <!-- <el-table-column
        label="实际下料"
        align="center"
        prop="deliveryDate"
        :formatter="dateFormatter"
        width="180px"
        sortable
      /> -->
      <el-table-column
        label="创建时间"
        align="center"
        prop="createTime"
        :formatter="dateFormatter"
        width="180px"
        sortable
      />
<el-table-column label="操作" align="center" fixed="right" width="350">
          <template #default="scope">
            <el-button
            link
            type="primary"
            v-hasPermi="['mes:item-requisition:update']"
            @click="changeStatus(scope.row.id)"
          >
            领料
          </el-button>
        </template>    
      </el-table-column>
    </el-table>
    <!-- 分页 -->
    <Pagination
      :total="total"
      v-model:page="queryParams.pageNo"
      v-model:limit="queryParams.pageSize"
      @pagination="getList"
    />
  </ContentWrap>

  <!-- 表单弹窗：添加/修改 -->
  <ItemRequisitionForm ref="formRef" @success="getList" />
</template>

<script setup lang="ts">
import {dateFormatter, dateFormatter2} from '@/utils/formatTime'
import download from '@/utils/download'
import { ItemRequisitionApi, ItemRequisitionVO } from '@/api/mes/itemrequisition'
import ItemRequisitionForm from './ItemRequisitionForm.vue'
import ItemRequisitionDetailList from './components/ItemRequisitionDetailList.vue'
import { getIntDictOptions, DICT_TYPE } from '@/utils/dict'

/** 生产领料 列表 */
defineOptions({ name: 'ItemRequisition' })

const message = useMessage() // 消息弹窗
const { t } = useI18n() // 国际化

const loading = ref(true) // 列表的加载中
const list = ref<ItemRequisitionVO[]>([]) // 列表的数据
const total = ref(0) // 列表的总页数
const queryParams = reactive({
  pageNo: 1,
  pageSize: 10,
  code: undefined,
  requisitionDate: [],
  deliveryDate: [],
  status: undefined,
  processInstanceId: undefined,
  planId: undefined,
  remark: undefined,
  isEnable: undefined,
  createTime: []
})
const queryFormRef = ref() // 搜索的表单
const exportLoading = ref(false) // 导出的加载中

/** 查询列表 */
const getList = async () => {
  loading.value = true
  try {
    const data = await ItemRequisitionApi.getItemRequisitionPage(queryParams)
    list.value = data.list
    total.value = data.total
  } finally {
    loading.value = false
  }
}

/** 搜索按钮操作 */
const handleQuery = () => {
  queryParams.pageNo = 1
  getList()
}

/** 重置按钮操作 */
const resetQuery = () => {
  queryFormRef.value.resetFields()
  handleQuery()
}

/** 添加/修改操作 */
const formRef = ref()
const openForm = (type: string, id?: number) => {
  formRef.value.open(type, id)
}

/** 删除按钮操作 */
const handleDelete = async (id: number) => {
  try {
    // 删除的二次确认
    await message.delConfirm()
    // 发起删除
    await ItemRequisitionApi.deleteItemRequisition(id)
    message.success(t('common.delSuccess'))
    // 刷新列表
    await getList()
  } catch {}
}

/** 导出按钮操作 */
const handleExport = async () => {
  try {
    // 导出的二次确认
    await message.exportConfirm()
    // 发起导出
    exportLoading.value = true
    const data = await ItemRequisitionApi.exportItemRequisition(queryParams)
    download.excel(data, '生产领料.xls')
  } catch {
  } finally {
    exportLoading.value = false
  }
}

/** 初始化 **/
onMounted(() => {
  getList()
})
/** tab 切换 */
// let activeName = ''
// const handleTabClick = (tab: TabsPaneContext) => {
//   queryParams.status = tab.paneName
//   handleQuery()
// }
const changeStatus = async (id: number) => {
try {
// 二次确认
    await message.confirm("确定领料吗?")
    await ItemRequisitionApi.changeStatus(id)
    message.success("领料成功！")
    // 刷新列表
    await getList()
  } catch {}
}
</script>
